﻿SystemOrganization addCategory: #'PicWorks-Core'!
SystemOrganization addCategory: #'PicWorks-Morphic'!

MorphicModel subclass: #PicAssemblerMorph
	instanceVariableNames: 'mainMorph labelMorphMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Morphic'!

!PicAssemblerMorph class methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 14:11'!
fromPath: aAsmPath
	| asmModel |
	asmModel := PicAssembler on: aAsmPath.
	Cursor wait showWhile: [
		asmModel analysis.]	.
	self new on: asmModel.
	! !

!PicAssemblerMorph class methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:43'!
fromUser
	"PicAssemblerMorph fromUser"
	| asmPath |
	asmPath := PicAssembler chooseCode.
	asmPath ifNil: [ ^ self ].
	MessageTally spyOn: [
		self fromPath: asmPath.]
	! !

!PicAssemblerMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:27'!
initialize
	super initialize.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.	
	mainMorph := AlignmentMorph inAColumn: #().
	mainMorph wrapCentering: #left.
	mainMorph cellPositioning: #leftCenter.
	mainMorph color: Color darkGray.
	self addMorph: mainMorph.
	! !

!PicAssemblerMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:03'!
labelMorphOf: aString 
	| morphs |
	labelMorphMap ifNil: 
		[ labelMorphMap := Dictionary new.
		morphs := self lookupLabelMorphs.
		morphs do: [:each | labelMorphMap at: (each contents) put: each] ].
	^labelMorphMap at: aString ifAbsent: [].! !

!PicAssemblerMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:35'!
labelMorphs
	^(mainMorph submorphs select: [:each | each hasLabel]) collect: [:each | each labelMorph].! !

!PicAssemblerMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:42'!
lookupLabelMorphs
	^ (mainMorph submorphs select: [ :each | each hasLabel ]) collect: [ :each | each labelMorph ]! !

!PicAssemblerMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:23'!
on: aPicAssemblerCode
	| m |
	self model: aPicAssemblerCode.
	self model codeHolders
		do: [ :holder  |
			m := PicCodeHolderMorph new on: holder.
			mainMorph addMorphBack: m].
	self inAScrollPane openInWindow.
		! !

MorphicModel subclass: #PicCodeHolderMorph
	instanceVariableNames: 'label instruction arguments comment leftValue rightValue define'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Morphic'!

!PicCodeHolderMorph class methodsFor: 'accessing' stamp: 'kf 10/3/2008 10:18'!
example
	"PicCodeHolderMorph example."
	PicCodeHolderMorph new openInWorld.! !

!PicCodeHolderMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 13:09'!
argumentMorphClass
	^PicArgumentsMorph.
	! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 14:20'!
beCommentOnly
	self hideMorphs: {label . instruction . arguments}.
! !

!PicCodeHolderMorph methodsFor: 'drawing' stamp: 'kf 10/6/2008 13:28'!
drawOn: aCanvas
	model ifNil: [^super drawOn: aCanvas].
	{rightValue . leftValue .  arguments} do: [:each | self setColorForMorph: each ].
	! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:38'!
hasLabel
	({'CB' . '__IDLOCS'} includes: label contents )
		ifTrue: [^false].
	^(label contents = '') not! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 14:19'!
hideMorphs: aMorphs
	aMorphs do: [:each | 
		each width: 0.
		each visible: false.]
! !

!PicCodeHolderMorph methodsFor: 'initialization' stamp: 'kf 10/3/2008 10:36'!
initialize
	super initialize.
	self initializeLayout.
	self setupMorphs.	
		! !

!PicCodeHolderMorph methodsFor: 'initialization' stamp: 'kf 10/7/2008 12:00'!
initializeLayout
	self 
		changeTableLayout;
		listDirection: #leftToRight;
		borderWidth: 1.
	self vResizing: #shrinkWrap.
	self hResizing: #spaceFill.
	self
		color: Color transparent;
		layoutInset: 1;
		wrapCentering: #center;
		cellPositioning: #leftCenter.		

	"self 
		borderColor: Color black;
		borderWidth: 1;"

		! !

!PicCodeHolderMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 14:34'!
labelMorph
	^label! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 18:01'!
macroInstructionColor
	^Color r: 0.8 g: 0.599 b: 1.0.! !

!PicCodeHolderMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 10:19'!
newContents: aString
	| sm |
	sm := self argumentMorphClass new contents: aString.
	^sm
	"sm colorProvider:  model parser assembler."
	! !

!PicCodeHolderMorph methodsFor: 'initialize-release' stamp: 'kf 10/4/2008 15:33'!
on: aPicCodeHolder
	self model: aPicCodeHolder.
	self submorphsDo: [:each | 
		each contents: ''.
		each colorProvider:  model parser assembler.].
	label contents: aPicCodeHolder label.
	leftValue contents: aPicCodeHolder leftValue.
	instruction  contents: aPicCodeHolder instructionWord.
	rightValue contents: aPicCodeHolder rightValue.
	arguments  contents: aPicCodeHolder arguments.
	comment  contents: aPicCodeHolder comment.
	self reLayout.! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 15:02'!
orderedStringMorphs
	^ { label  . leftValue . instruction  . rightValue . arguments . comment}
! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 14:38'!
orderedStringMorphsForDefine
	^ { label  . instruction . leftValue .  rightValue . arguments . comment}
! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 17:58'!
pseudoColor
	^Color r: 0.599 g: 0.599 b: 1.0.! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:22'!
reLayout
	label width: 100.
	leftValue width: 100.
	rightValue width: 100.
	instruction width: 100.
	arguments width: 200.
	self refreshArgumentMorphs.	
	self model ifNil: [^self].
	self model leftValue ifEmpty: [self hideMorphs: {leftValue}].
	self model rightValue ifEmpty: [self hideMorphs: {rightValue}].
	self model isPseudo 
		ifTrue: [
			instruction color: self pseudoColor.
			(({'EQU' . 'RES'} includes: self model operation)
				ifTrue: [{label . arguments}]
				ifFalse: [{label . arguments . leftValue}])
		 		do: [:each | each visible: false].].
	self model isDefine ifTrue: [ 
		self hideMorphs: {label . arguments}.
		self removeAllMorphs.
		self orderedStringMorphsForDefine
			do: [: each | self addMorphBack: each].].
	(self model isNoEffect )
		ifTrue: [
			self beCommentOnly. 
			^self].
	
	
! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:20'!
refreshArgumentMorphs
	self orderedStringMorphs do: [:each | 
		each position: each position + 1.
		each position: each position - 1.].
		! !

!PicCodeHolderMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 13:27'!
setColorForMorph: aStringMorph
	 aStringMorph contents ifNotEmpty: [aStringMorph color: (model parser assembler colorForWord: aStringMorph contents)].
	! !

!PicCodeHolderMorph methodsFor: 'initialization' stamp: 'kf 10/4/2008 15:17'!
setupMorphs
	label := (self newContents: ' right parenthesis expected ->_LABEL') color: Color yellow.
	instruction := (self newContents: 'EXAMPLE_INSTRUCTION') color: Color cyan.
	arguments := (self newContents: 'ARG1,ARG2,ARG3') color: Color cyan.
	comment := (self newContents: ';example comment strings') color: Color green.
	leftValue := (self newContents: 'FUCK') color: Color white.
	rightValue := (self newContents: '5') color: Color white.
	 self orderedStringMorphs
		do: [: each | self addMorphBack: each].
	self reLayout.
	self changed.	! !

Object subclass: #PicAssembler
	instanceVariableNames: 'codeHolders codePath userDefinedVariableNames userDefinedLabelNames'
	classVariableNames: 'MacroInstructions Instructions'
	poolDictionaries: ''
	category: 'PicWorks-Core'!

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 13:33'!
chooseCode
	"PicWorks chooseCode"
	^((FileList2 
			modalFileSelectorForSuffixes: #('asm')
			directory:  (FileDirectory on: self defaultCodePath  ) ) name)! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 13:34'!
chooseIncludeCode
	"PicAssembler chooseIncludeCode"
	^((FileList2 
			modalFileSelectorForSuffixes: #('asm' 'inc')
			directory:  (FileDirectory on: self defaultIncludePath  ) ) name)! !

!PicAssembler class methodsFor: 'defaults' stamp: 'kf 4/30/2009 23:19'!
defaultCodePath
	^'C:\'.
	
	! !

!PicAssembler class methodsFor: 'defaults' stamp: 'kf 10/6/2008 13:34'!
defaultIncludePath
	^'C:\Program FIles\gputils\header'.
	
	! !

!PicAssembler class methodsFor: 'initialization' stamp: 'kf 10/7/2008 10:48'!
initialize
	"PicAssembler initialize"
	super initialize.
	Instructions := nil.
	MacroInstructions := nil.
	 	 ! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 15:07'!
instructionSpecText
	^'
ADDWF f, d Add W and f 1 00 0111 dfff ffff C,DC,Z 1,2
ANDWF f, d AND W with f 1 00 0101 dfff ffff Z 1,2
CLRF f Clear f 1 00 0001 lfff ffff Z 2
CLRW - Clear W 1 00 0001 0xxx xxxx Z
COMF f, d Complement f 1 00 1001 dfff ffff Z 1,2
DECF f, d Decrement f 1 00 0011 dfff ffff Z 1,2
DECFSZ f, d Decrement f, Skip if 0 1(2) 00 1011 dfff ffff 1,2,3
INCF f, d Increment f 1 00 1010 dfff ffff Z 1,2
INCFSZ f, d Increment f, Skip if 0 1(2) 00 1111 dfff ffff 1,2,3
IORWF f, d Inclusive OR W with f 1 00 0100 dfff ffff Z 1,2
MOVF f, d Move f 1 00 1000 dfff ffff Z 1,2
MOVWF f Move W to f 1 00 0000 lfff ffff
NOP - No Operation 1 00 0000 0xx0 0000
RLF f, d Rotate Left f through Carry 1 00 1101 dfff ffff C 1,2
RRF f, d Rotate Right f through Carry 1 00 1100 dfff ffff C 1,2
SUBWF f, d Subtract W from f 1 00 0010 dfff ffff C,DC,Z 1,2
SWAPF f, d Swap nibbles in f 1 00 1110 dfff ffff 1,2
XORWF f, d Exclusive OR W with f 1 00 0110 dfff ffff Z 1,2
BIT-ORIENTED FILE REGISTER OPERATIONS
BCF f, b Bit Clear f 1 01 00bb bfff ffff 1,2
BSF f, b Bit Set f 1 01 01bb bfff ffff 1,2
BTFSC f, b Bit Test f, Skip if Clear 1 (2) 01 10bb bfff ffff 3
BTFSS f, b Bit Test f, Skip if Set 1 (2) 01 11bb bfff ffff 3
LITERAL AND CONTROL OPERATIONS
ADDLW k Add literal and W 1 11 111x kkkk kkkk C,DC,Z
ANDLW k AND literal with W 1 11 1001 kkkk kkkk Z
CALL k Call subroutine 2 10 0kkk kkkk kkkk
CLRWDT - Clear Watchdog Timer 1 00 0000 0110 0100 TO,PD
GOTO k Go to address 2 10 1kkk kkkk kkkk
IORLW k Inclusive OR literal with W 1 11 1000 kkkk kkkk Z
MOVLW k Move literal to W 1 11 00xx kkkk kkkk
RETFIE - Return from interrupt 2 00 0000 0000 1001
RETLW k Return with literal in W  2 11 01xx kkkk kkkk
RETURN - Return from Subroutine 2 00 0000 0000 1000
SLEEP - Go into Standby mode 1 00 0000 0110 0011 TO,PD
SUBLW k Subtract W from literal 1 11 110x kkkk kkkk C,DC,Z
XORLW k Exclusive OR literal with W 1 11 1010 kkkk kkkk Z	'! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 15:07'!
instructions
	Instructions ifNil: [Instructions := self lookupInstructions].
	^Instructions! !

!PicAssembler class methodsFor: 'testing' stamp: 'kf 10/2/2008 15:26'!
isACommentLine: aString
	^aString trimBlanks beginsWith: ';'! !

!PicAssembler class methodsFor: 'testing' stamp: 'kf 10/7/2008 15:59'!
isAInstructionLine: aString 
	^ PicAssembler isInstruction: (aString trimBlanks findTokens: Character separators) first! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 15:58'!
isInstruction: aWord
	^self instructions includes: aWord asUppercase.! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:47'!
lookupInstructions
	| col |
	col := OrderedCollection new.
	self instructionSpecText linesDo: [ :line |
		(line trimBlanks size >= 3)		 
			ifTrue: [col add: (line findTokens: Character separators) first]].
	^col asSet.! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:47'!
lookupMacroInstructions
	| col |
	col := OrderedCollection new.
	col add: 'BC'.
	col add: 'BNC'.
	col add: 'BZ'.
	col add: 'BNZ'.
	col add: 'TSTF'.	
	col add: 'SKPZ'.			
	col add: 'SKPNZ'.			
	^col asSet.! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 13:09'!
macroInstructions
	MacroInstructions ifNil: [MacroInstructions := self lookupMacroInstructions].
	^MacroInstructions! !

!PicAssembler class methodsFor: 'initialize-release' stamp: 'kf 10/6/2008 09:54'!
on: aAsmCodePath
	^self new on: aAsmCodePath.! !

!PicAssembler class methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 15:13'!
pseudoInstructions
	^{ 'ORG' . 'RES' .  'EQU' . 'DE' . 'LIST' . 'INCLUDE' . '__CONFIG' . 'CBLOCK' . 'ENDC' . 'END' }! !

!PicAssembler methodsFor: 'private' stamp: 'kf 10/6/2008 14:13'!
analysis
	self codeHolders.
	self userReservedVariableNames.! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/7/2008 16:46'!
balloonTextForWord: aWord
	|holder |
	holder := (self lookupCodesForOperations: {'EQU' . 'RES' . '#define'}) detect: [:each |
		each leftValue sameAs: aWord] ifNone: [].
	holder ifNil: [^nil].
	^holder commentBody.
	! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/7/2008 10:53'!
builtinInstructionColor
	^Color cyan! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/6/2008 11:35'!
cantResolvedColor
	^Color white.! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 09:56'!
codeHolders	
	^self codeHolders: self codePath.! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/4/2008 17:56'!
codeHolders: aAsmCodePath
	codeHolders ifNil: [codeHolders := self lookupCodeHolders: aAsmCodePath].
	^codeHolders.! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/6/2008 09:53'!
codePath
	^codePath
	! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/7/2008 16:00'!
colorForWord: aWord 
	(aWord beginsWith: ';') ifTrue: [^self commentColor].
	(self isInstruction: aWord) ifTrue: [ ^self builtinInstructionColor ].
	(self userReservedVariableNames includes: aWord) ifTrue: [ ^ self userReservedVariableColor ].
	(self userDefinedLabelNames includes: aWord) ifTrue: [ ^ self labelColor ].
	(self isLiteral: aWord) ifTrue: [ ^ self literalColor ].
	({  'F'. 'W'  } includes: aWord) ifTrue: [ ^ self builtinInstructionColor ].
	(self class pseudoInstructions includes: aWord) ifTrue: [ ^self pseudoInstructionColor ].
	^ self cantResolvedColor! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/7/2008 10:48'!
commentColor
	^Color green.! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/6/2008 09:55'!
example
	"PicAssembler new example"
	| asmPath mainMorph m  asmModel |
	
	asmPath := PicAssembler chooseCode.
	asmPath ifNil: [ ^ self ].
	asmModel := PicAssembler on: asmPath.
	mainMorph := AlignmentMorph inAColumn: #().
	mainMorph wrapCentering: #left.
	mainMorph cellPositioning: #leftCenter.
	mainMorph color: Color darkGray.
	Cursor wait showWhile: [ 
		(self codeHolders: asmPath)
			do: [ :holder  |
				m := PicCodeHolderMorph new on: holder.
				mainMorph addMorphBack: m].].
	mainMorph inAScrollPane openInWindow.
	PicArgumentsMorph allInstances do: [:each | 
		each position: each position + 1.
		each position: each position - 1.].
	! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 15:59'!
isInstruction: aWord
	^self class isInstruction: aWord! !

!PicAssembler methodsFor: 'testing' stamp: 'kf 10/7/2008 17:01'!
isLiteral: aString
	((aString asUppercase beginsWith: 'H''' ) and: [aString endsWith: '''' ])
		ifTrue: [^true].
	((aString asUppercase beginsWith: 'B''' ) and: [aString endsWith: '''' ])
		ifTrue: [^true].		
	^aString isAllDigits.  ! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/6/2008 11:28'!
labelColor
	^Color yellow.! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/6/2008 11:32'!
literalColor
	^Color red.! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 17:55'!
lookupCodeHolders: aAsmCodePath
	^(self lookupLinePersers: aAsmCodePath)
		collect: [:each | each codeHolder].! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:35'!
lookupCodesForOperation: aString
	^ self codeHolders select: [ :each | each operation sameAs: aString ]! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:42'!
lookupCodesForOperations: aCollection
	^ self codeHolders select: [ :each | aCollection anySatisfy: [:each2 | each operation sameAs: each2 ]]! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 15:24'!
lookupLinePersers: aAsmCodePath
	| col  parser |
	col := OrderedCollection new.
	(TextViewer readContentsShiftJIS: aAsmCodePath)
		 linesDo: [ :line | 
			line trimBlanks size = 0 
				ifFalse: [ 
					parser := PicCodeLineParser new line: line.
					parser assembler: self.
					col add: parser.]].
	^col asArray.! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/6/2008 14:00'!
lookupPicListCode
	^self codeHolders detect: [:each | each isPseudo and: [each operation = 'LIST']] ifNone: [].! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 11:17'!
lookupUserDefinedLabelCodes
	^self codeHolders select: [:each |
		each label size > 0]! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:36'!
lookupUserReservedVariableCodes
	^ self lookupCodesForOperation:  'RES'.! !

!PicAssembler methodsFor: 'initialize-release' stamp: 'kf 10/6/2008 09:52'!
on: aAsmCodePath
	codePath := aAsmCodePath.
	! !

!PicAssembler methodsFor: 'initialization' stamp: 'kf 10/6/2008 09:57'!
openInWindow
	"PicAssembler new example"
	| asmPath mainMorph m  asmModel |
	
	asmPath := PicAssembler chooseCode.
	asmPath ifNil: [ ^ self ].
	asmModel := PicAssembler on: asmPath.
	mainMorph := AlignmentMorph inAColumn: #().
	mainMorph wrapCentering: #left.
	mainMorph cellPositioning: #leftCenter.
	mainMorph color: Color darkGray.
	Cursor wait showWhile: [ 
		(self codeHolders: asmPath)
			do: [ :holder  |
				m := PicCodeHolderMorph new on: holder.
				mainMorph addMorphBack: m].].
	mainMorph inAScrollPane openInWindow.
	PicArgumentsMorph allInstances do: [:each | 
		each position: each position + 1.
		each position: each position - 1.].
	! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/6/2008 14:05'!
pathForInclude
	^(self class defaultIncludePath, FileDirectory slash , self picName asLowercase , '.inc')! !

!PicAssembler methodsFor: 'accessing' stamp: 'kf 10/6/2008 14:03'!
picName
	| listCode |
	listCode := self lookupPicListCode.
	listCode ifNil: [^''].
	^(listCode operands first splitOn: '=') last.! !

!PicAssembler methodsFor: 'printing' stamp: 'kf 10/6/2008 10:42'!
printOn: aStream
	super printOn: aStream.
	codePath ifNil: [^self].
	aStream nextPutAll: '('.	
	aStream nextPutAll: (FileDirectory default localNameFor: codePath).
	aStream nextPutAll: ')'.	
	! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/7/2008 11:09'!
pseudoInstructionColor
	^Color r: 0.599 g: 0.599 b: 1.0.! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 14:30'!
userDefinedLabelNames
	userDefinedLabelNames ifNil: [userDefinedLabelNames :=( self lookupUserDefinedLabelCodes collect: [:each | each label ] ) asSet].
	^userDefinedLabelNames! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/6/2008 11:29'!
userDefinedVariableColor
	^Color orange.! !

!PicAssembler methodsFor: 'color' stamp: 'kf 10/6/2008 13:22'!
userReservedVariableColor
	^Color orange.! !

!PicAssembler methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 13:21'!
userReservedVariableNames
	userDefinedVariableNames ifNil: 
		[ userDefinedVariableNames := self lookupUserReservedVariableCodes collect: [ :each | each leftValue ] ].
	^ userDefinedVariableNames! !

Object subclass: #PicCodeHolder
	instanceVariableNames: 'comment operation colOperands label leftLabel parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Core'!

!PicCodeHolder methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 15:45'!
addOperand: aWord 
	colOperands add: aWord! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 10:41'!
arguments
	^self operands joinUsing: ','.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/2/2008 15:23'!
comment
	^comment.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/2/2008 15:31'!
comment: aString
	comment := aString ! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/6/2008 17:06'!
commentBody
	(self comment beginsWith: ';')
		ifTrue: [^self comment copyFrom: 2 to: self comment size].
	^self comment.! !

!PicCodeHolder methodsFor: 'initialization' stamp: 'kf 10/3/2008 15:23'!
initialize
	comment := ''.
	operation := ''.
	label := ''.
	colOperands := OrderedCollection new.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 15:23'!
instructionWord
	^self operation.
	! !

!PicCodeHolder methodsFor: 'testing' stamp: 'kf 10/3/2008 17:25'!
isDefine
	^self parser type = #preprocessorCode.! !

!PicCodeHolder methodsFor: 'testing' stamp: 'kf 10/3/2008 15:22'!
isNoEffect
	^{label  . operation  }
		allSatisfy: [:each | each size = 0].  ! !

!PicCodeHolder methodsFor: 'testing' stamp: 'kf 10/3/2008 15:21'!
isPseudo
	^self parser type = #pseudoCode.! !

!PicCodeHolder methodsFor: 'testing' stamp: 'kf 10/3/2008 15:22'!
isReal
	^self parser type = #realCode.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 10:44'!
label
	^label! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/2/2008 17:28'!
label: aString
	label :=  aString.
	! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 17:38'!
leftValue
	self parser words ifEmpty: [^''].
	(self isPseudo or: [self isDefine]) ifFalse: [^''].
	self isDefine
		ifTrue: [^self parser words second].
	self isPseudo
		ifTrue: [
			({'DE' . 'ORG' . 'END'} includes: self operation) ifTrue: [^''].
			^self parser words first].
		! !

!PicCodeHolder methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 15:23'!
operands
	^colOperands asArray.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/2/2008 15:23'!
operation
	^operation.! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/2/2008 15:39'!
operation: aString
	operation := aString.
	! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 14:27'!
parser
	^parser! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 14:25'!
parser: aPicCodeLineParser
	parser := aPicCodeLineParser! !

!PicCodeHolder methodsFor: 'accessing' stamp: 'kf 10/3/2008 17:43'!
rightValue
	(self isPseudo or: [self isDefine]) ifFalse: [^''].
	self parser words ifEmpty: [^''].
	self isDefine
		ifTrue: [^self parser words last].
	self isPseudo
		ifTrue: [
			({'END'} includes: self operation) ifTrue: [^''].
			^self parser words last].
		! !

Object subclass: #PicCodeLineParser
	instanceVariableNames: 'line trimedLine commentLeft commentRight words type instruction assembler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Core'!

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/4/2008 15:23'!
assembler
	^assembler! !

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/4/2008 15:22'!
assembler: aPicAssembler
	assembler := aPicAssembler.! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/3/2008 17:20'!
codeHolder
	| holder |
	holder := PicCodeHolder new parser: self.
	holder comment: commentRight.
	(type = #preprocessorCode)
		ifTrue: [
			self setupPreprocessorCode: holder.
			^holder].
	(type = #pseudoCode)
		ifTrue: [
			self setupPseudoCode: holder.
			^holder].
	(type = #realCode)
		ifTrue: [
			self setupRealCode: holder.
			^holder].
	(type = #macroCallCode)
		ifTrue: [
			self setupMacroCallCode: holder.
			^holder].
	words size >= 1
		ifTrue: [holder label: words first].	
	^holder.! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/2/2008 17:18'!
hasComment
	^commentRight size > 0.! !

!PicCodeLineParser methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 16:51'!
inspectLine
	trimedLine := line trimBlanks.
	self splitComment.
	self splitWords.
	self inspectTypes.
		! !

!PicCodeLineParser methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:00'!
inspectTypes
	| hit |
	instruction = ''.
	type := #none.
	words size = 0 ifTrue: [ ^ self ].
	(words first beginsWith: '#') ifTrue: 
		[ type := #preprocessorCode.
		instruction := words first.
		^ self ].
	hit := words 
		detect: [ :each | PicAssembler pseudoInstructions includes: each ]
		ifNone: [ nil ].
	hit ifNotNil: 
		[ type := #pseudoCode.
		instruction := hit.
		^ self ].
	hit := words 
		detect: [ :each | PicAssembler isInstruction: each ]
		ifNone: [ nil ].
	hit ifNotNil: 
		[ type := #realCode.
		instruction := hit.
		^ self ].
	hit := words 
		detect: [ :each | PicAssembler macroInstructions includes: each ]
		ifNone: [ nil ].
	hit ifNotNil: 
		[ type := #macroCallCode.
		instruction := hit.
		^ self ]! !

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/3/2008 15:18'!
instruction
	^instruction! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/2/2008 17:19'!
isAllComment
	^commentLeft trimBlanks size  = 0.! !

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/2/2008 16:45'!
line: aString 
	line := aString.
	self inspectLine.
	
		! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/3/2008 15:20'!
setupMacroCallCode: aPicCodeHolder
	aPicCodeHolder operation: instruction.
	words size < 2 ifTrue: [^self].
	(words second findTokens: ',')
		do: [ :each | aPicCodeHolder addOperand: each ]! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/3/2008 17:18'!
setupPreprocessorCode: aPicCodeHolder
	aPicCodeHolder operation: instruction.
	words size < 2 ifTrue: [^self].
	(words second findTokens: ',')
		do: [ :each | aPicCodeHolder addOperand: each ]! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/3/2008 15:19'!
setupPseudoCode: aPicCodeHolder
	aPicCodeHolder operation: instruction.
	words size < 2 ifTrue: [^self].
	(words second findTokens: ',')
		do: [ :each | aPicCodeHolder addOperand: each ]! !

!PicCodeLineParser methodsFor: 'testing' stamp: 'kf 10/3/2008 15:19'!
setupRealCode: aPicCodeHolder
	aPicCodeHolder operation: instruction.
	words size < 2 ifTrue: [^self].
	(words second findTokens: ',')
		do: [ :each | aPicCodeHolder addOperand: each ]! !

!PicCodeLineParser methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 17:13'!
splitComment
	|  index  |
	commentLeft := ''.
	commentRight := ''.
	index := line findString: ';'.
	index = 0
		ifTrue: [^commentLeft := line].		
	index >= 2 
		ifTrue:[			
			commentLeft := (line copyFrom: 1 to: index - 1) trimBlanks.].
	commentRight := (line copyFrom: index to: line size) trimBlanks.
	! !

!PicCodeLineParser methodsFor: 'as yet unclassified' stamp: 'kf 10/2/2008 17:00'!
splitWords
	commentLeft ifEmpty: [
		words :=#() copy.
		^self].
	words := commentLeft findTokens: Character separators.
		! !

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/3/2008 15:20'!
type
	^type.! !

!PicCodeLineParser methodsFor: 'accessing' stamp: 'kf 10/3/2008 14:29'!
words
	^words! !

StringMorph subclass: #PicArgumentsMorph
	instanceVariableNames: 'colorProvider arguments wordMorps separatorMorph col displayMorphs blinkEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Morphic'!

!PicArgumentsMorph class methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 15:04'!
example
	"PicArgumentsMorph example"
	(PicArgumentsMorph new contents: 'ARG1,ARG2,ARG3') openInWorld.

! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/6/2008 16:49'!
balloonText
	colorProvider ifNil: [^super balloonText.].
	^colorProvider balloonTextForWord: self contents.! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 17:53'!
blinkEnabled
	blinkEnabled ifNil: [blinkEnabled := false].
	^blinkEnabled
	! !

!PicArgumentsMorph methodsFor: 'testing' stamp: 'kf 10/4/2008 15:13'!
canOwnDraw
	arguments ifNil: [^false].
	arguments size <= 1 ifTrue: [^false].
	wordMorps ifNil: [^false].
	wordMorps size <= 1 ifTrue: [^false].
	colorProvider ifNil:[^false].
	^colorProvider respondsTo: #colorForWord:
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 13:49'!
color: aColor
	super color: aColor.
	wordMorps ifNil: [^self].
	wordMorps size = 1 ifTrue: [
		wordMorps first color: aColor.
		wordMorps first changed].
! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 19:01'!
colorProvider: aColorProvider
	colorProvider := aColorProvider.
	"self displayMorphs  do: [ :each |
		self addMorphBack: each.
		each color:( colorProvider colorForWord: each contents).
		each setBalloonText: (colorProvider balloonTextForWord: each contents)]."
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 16:01'!
contents
	(PicAssembler isInstruction: super contents)
		ifTrue: [^super contents asLowercase]. 
	^super contents! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 16:12'!
contents: aString	
	(PicAssembler isInstruction: aString)
		ifTrue: [super contents:   aString asLowercase]
		ifFalse: [super contents: aString].
	displayMorphs := nil.
	arguments := self contents splitOn: ','.
	wordMorps := OrderedCollection new.
	arguments do: [:each |
	wordMorps add: (StringMorph new contents: each).].
	wordMorps do: [:each | each fitContents].
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 15:11'!
displayMorphs
	displayMorphs ifNil: [displayMorphs := self lookupDisplayMorphs ].
	^displayMorphs.! !

!PicArgumentsMorph methodsFor: 'drawing' stamp: 'kf 10/7/2008 16:14'!
drawOn: aCanvas
	self setAttributesToSubmorphs.
	"super drawOn: aCanvas."! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 13:16'!
extent: aPoint
	super extent: aPoint.
! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 15:07'!
hitLabel
	Transcript cr; show: self contents.
	! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 18:16'!
hitLabel: aEvent
	| m mm mmm|
	Transcript cr; show: aEvent .
	m := self submorphs detect: [:each | each bounds containsPoint: aEvent cursorPoint] ifNone: [].
	m ifNil:[^self].
	 Transcript cr; show: m.
	mm := self ownerThatIsA: PicAssemblerMorph.
	mm ifNil:[^self].
	 Transcript cr; show: mm.
	mmm := mm labelMorphOf: m contents.
	mmm ifNil:[^self].
	 Transcript cr; show: mmm.
	(m == mmm) ifTrue: [^Transcript cr; show: 'Label own'].
	(m owner == mmm) ifTrue: [^Transcript cr; show: 'Label own'].
	mmm startBlink.
	mmm changed! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/8/2008 10:20'!
hitLabelBlink: aEvent
	| m asmMorph labelMorph distance scrollPane beforeJumpOffset afterJumpOffset jumpBounds |
	Transcript cr; show: aEvent .
	m := self submorphs detect: [:each | each bounds containsPoint: aEvent cursorPoint] ifNone: [].
	m ifNil:[^self].
	 Transcript cr; show: m.
	asmMorph := self ownerThatIsA: PicAssemblerMorph.
	asmMorph ifNil:[^self].
	 Transcript cr; show: asmMorph.
	labelMorph := asmMorph labelMorphOf: m contents.
	labelMorph ifNil:[^self].
	 Transcript cr; show: labelMorph.
	scrollPane := (asmMorph ownerThatIsA: ScrollPane).
	scrollPane ifNil: [^self]. 
	(m == labelMorph) ifTrue: [^Transcript cr; show: 'Label own'].
	(m owner == labelMorph) 
		ifTrue: 
			[.
			^Transcript cr; show: 'Label own'].
	distance := m top - labelMorph top.
	beforeJumpOffset := scrollPane scroller offset.
	jumpBounds := (distance abs <= scrollPane scroller height)
		ifTrue: [m bounds merge: labelMorph bounds]
		ifFalse:[labelMorph bounds].
	jumpBounds = labelMorph bounds
		ifFalse: [	
			scrollPane scrollToShow: jumpBounds.
			afterJumpOffset := scrollPane scroller offset.
			labelMorph startBlink.
			labelMorph changed.]
		ifTrue: [
			self setProperty: #longJumpBounds toValue: labelMorph bounds.
			labelMorph setProperty: #beforeOffset toValue: beforeJumpOffset.
			labelMorph on: #mouseUp send: #jumpIfPushed: to: labelMorph.
 			self startBlink].
	! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 20:24'!
hitLongJump: aEvent
	| m asmMorph labelMorph distance scrollPane beforeJumpOffset afterJumpOffset jumpBounds |
	Transcript cr; show: aEvent .
	m := self submorphs detect: [:each | each bounds containsPoint: aEvent cursorPoint] ifNone: [].
	m ifNil:[^self].
	 Transcript cr; show: m.
	asmMorph := self ownerThatIsA: PicAssemblerMorph.
	asmMorph ifNil:[^self].
	 Transcript cr; show: asmMorph.
	labelMorph := asmMorph labelMorphOf: m contents.
	labelMorph ifNil:[^self].
	 Transcript cr; show: labelMorph.
	scrollPane := (asmMorph ownerThatIsA: ScrollPane).
	scrollPane ifNil: [^self]. 
	(m == labelMorph) ifTrue: [^Transcript cr; show: 'Label own'].
	(m owner == labelMorph) 
		ifTrue: 
			[labelMorph valueOfProperty: #beforeOffset  ifPresentDo: [:value | scrollPane scroller offset: value ].
			^Transcript cr; show: 'Label own'].
	distance := m top - labelMorph top.
	jumpBounds := (distance abs <= scrollPane scroller height)
		ifTrue: [m bounds merge: labelMorph bounds]
		ifFalse:[labelMorph bounds].
	jumpBounds = labelMorph bounds
		ifFalse: [	
			beforeJumpOffset := scrollPane scroller offset.
			scrollPane scrollToShow: jumpBounds.
			afterJumpOffset := scrollPane scroller offset.
			labelMorph startBlink.
			labelMorph changed.]
		ifTrue: [
			self setProperty: #needsLongJump toValue: true.
			labelMorph setProperty: #beforeOffset toValue: beforeJumpOffset.
			labelMorph on: #mouseUp send: #jumpIfPushed: to: labelMorph.
 			self startBlink].
	! !

!PicArgumentsMorph methodsFor: 'accessing' stamp: 'kf 10/7/2008 15:04'!
initialize
	super initialize.
	"self on: #mouseDown send: #hitLabel to: self."! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 21:00'!
jumpIfPushed: aEvent
	Transcript cr; show: aEvent.
	self valueOfProperty: #longJumpBounds ifPresentDo: [:value |
		(self ownerThatIsA: ScrollPane)  scrollToShow: value.
		self removeProperty: #longJumpBounds.].
	self valueOfProperty: #beforeOffset ifPresentDo: [:value |
		(self ownerThatIsA: ScrollPane)  scroller offset: value.
		self removeProperty: #beforeOffset].
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 15:10'!
lookupDisplayMorphs
	wordMorps ifNil: [^#() copy].
	col := OrderedCollection new.
	wordMorps do: [:each |
		col add: each.
		col add: self separatorMorph].
	^col allButLast asArray.! !

!PicArgumentsMorph methodsFor: 'geometry' stamp: 'kf 10/7/2008 13:33'!
position: aPoint
	| x |
	super position: aPoint.
	x := aPoint x.
	self removeAllMorphs.
	self displayMorphs do: [:each |
		self addMorphBack: each. 
		each position: (x@aPoint y).
		x := x + each width. ].! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/4/2008 15:08'!
separatorMorph
	| m |
	m := StringMorph new contents: ','.
	m fitContents.
	^m
		
	
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 20:34'!
setAttributesToSubmorphs
	colorProvider ifNil: [^self].
	(self displayMorphs  reject: [ :each |each hasProperty: #attributeSetted ])
		do: [:each |
			each color:( colorProvider colorForWord: each contents).
			each setBalloonText: (colorProvider balloonTextForWord: each contents).
			each on: #mouseEnter send: #hitLabelBlink: to: self.
			each on: #mouseUp send: #jumpIfPushed: to: self.
			each setProperty: #attributeSetted toValue: true].
! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:25'!
startBlink
	self setProperty: #blinkCount toValue: 0.
	self startStepping.
	blinkEnabled := true.
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:33'!
step
	| m c |	
	self blinkEnabled ifFalse: [^super step.].
	m := displayMorphs first.
	m emphasis: (m emphasis = 1 ifTrue: [0] ifFalse: [1]).
	c := self valueOfProperty: #blinkCount ifAbsent: [0].
	c > 5 ifTrue: [^self stopBlink.].
	self setProperty: #blinkCount toValue: (c + 1).
! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:49'!
stepTime
	self blinkEnabled ifTrue: [^200.].
	^super stepTime.
	! !

!PicArgumentsMorph methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:36'!
stopBlink
	blinkEnabled := false.
	self stopStepping.
	displayMorphs first emphasis: 0.! !

!StringMorph methodsFor: '*PicWorks' stamp: 'kf 10/7/2008 18:23'!
emphasis
	^emphasis.! !

AlignmentMorph subclass: #PicArgumentsMorphEx
	instanceVariableNames: 'contents displayMorphs arguments wordMorps colorProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PicWorks-Morphic'!

!PicArgumentsMorphEx class methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 17:51'!
contents: aString
	^self new contents: aString.! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 18:16'!
balloonText
	colorProvider ifNil: [^super balloonText.].
	^colorProvider balloonTextForWord: self contents.! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:12'!
color: aColor
	wordMorps ifNil: [^super color: aColor].
	wordMorps size = 1 ifTrue: [
		wordMorps first color: aColor.
		wordMorps first changed].
	self changed.! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 18:59'!
colorProvider: aColorProvider
	colorProvider := aColorProvider.
	"self displayMorphs  do: [ :each |
		each color:( colorProvider colorForWord: each contents).
		each setBalloonText: (colorProvider balloonTextForWord: each contents)].
	self changed."! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 17:42'!
contents
	^contents! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 11:34'!
contents: aString
	contents := aString.
	displayMorphs := nil.
	arguments :=  (aString beginsWith: ';')
		ifTrue: [Array with: aString]
		ifFalse: [self contents splitOn: ','.].	
	wordMorps := OrderedCollection new.
	arguments do: [:each | wordMorps add: (StringMorph new contents: each).].
	wordMorps do: [:each | 
		each fitContents.].
	self removeAllMorphs.
	self displayMorphs do: [:each |
		self addMorphBack: each].
	self layoutChanged.
		! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 17:37'!
displayMorphs
	displayMorphs ifNil: [displayMorphs := self lookupDisplayMorphs ].
	^displayMorphs.! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:45'!
drawOn: aCanvas
	self setAttributesToSubmorphs.
	super drawOn: aCanvas.
	! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 11:42'!
initialize
	super initialize.

	self color: Color transparent.
	self layoutInset: 1.
	self changeTableLayout.
	self listDirection: #leftToRight.
"		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutInset: 1;.
		wrapCentering: #center;
		cellPositioning: #leftCenter.		

"
	self contents: ''! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 17:34'!
lookupDisplayMorphs
	| col |
	wordMorps ifNil: [^#() copy].
	col := OrderedCollection new.
	wordMorps do: [:each |
		col add: each.
		col add: self separatorMorph].
	^col allButLast asArray.! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/6/2008 17:43'!
separatorMorph
	| m |
	m := StringMorph new contents: ','.
	m fitContents.
	^m! !

!PicArgumentsMorphEx methodsFor: 'as yet unclassified' stamp: 'kf 10/7/2008 10:44'!
setAttributesToSubmorphs
	colorProvider ifNil: [^self].
	self displayMorphs  do: [ :each |
	(each hasProperty: #attributeSetted)
		ifFalse: [
			each color:( colorProvider colorForWord: each contents).
			each setBalloonText: (colorProvider balloonTextForWord: each contents).
			each setProperty: #attributeSetted toValue: true]].
! !
PicAssembler initialize!
